SystemOrganization addCategory: #'Limbo-Core'!
SystemOrganization addCategory: #'Limbo-Core-Exceptions'!

Error subclass: #LimboError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core-Exceptions'

	classInstanceVariableNames:''!

Object subclass: #Limbo
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core'

	classInstanceVariableNames:''!

!Limbo class methodsFor: 'instance creation' stamp: 'MML 11/14/2012 18:55'!
run: aString arguments: aCollection
	^ self new
		run: aString arguments: aCollection;
		yourself! !

!Limbo class methodsFor: 'instance creation' stamp: 'MML 11/14/2012 17:02'!
runSh: aString
	^ self new
		runSh: aString;
		yourself! !

!Limbo methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:47'!
command
	^ command ifNil: [ command := LimboCommand new ]! !

!Limbo methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:42'!
command: aLimboCommand
	command := aLimboCommand! !

!Limbo methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:43'!
errorString
	^ self command errorString! !

!Limbo methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:43'!
outString
	^ self command outString! !

!Limbo methodsFor: 'running' stamp: 'MML 11/14/2012 18:46'!
run: aString arguments: aCollection
	self command
		command: aString;
		arguments: aCollection;
		run! !

!Limbo methodsFor: 'running' stamp: 'MML 11/14/2012 18:32'!
runSh: aString
	self run: '/bin/sh' arguments: { '-c'. aString }! !

Object subclass: #LimboCommand
	instanceVariableNames: 'command arguments outString errorString pointers exitStatus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core'

	classInstanceVariableNames:''!

!LimboCommand class methodsFor: 'instance creation' stamp: 'MML 11/14/2012 17:15'!
command: aString arguments: aCollection
	^ self new
		command: aString;
		arguments: aCollection;
		yourself! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 17:12'!
arguments
	^ arguments! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 17:11'!
arguments: aCollection
	arguments := aCollection! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 17:11'!
command
	^ command! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 17:11'!
command: aString
	command := aString! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:42'!
errorString
	^ errorString! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:42'!
errorString: aString
	errorString := aString! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/15/2012 16:37'!
exitStatus
	^ exitStatus! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/15/2012 16:37'!
exitStatus: aNumber
	exitStatus := aNumber! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/15/2012 15:26'!
freePointers
	self pointers do: [ :pointer | pointer value free ].
	pointers := nil! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/15/2012 15:24'!
integerPointer
	| pointer |
	pointer := NativeBoost allocate: 4.
	self registerPointer: pointer named: 'integer pointer'.
	^ pointer! !

!LimboCommand methodsFor: 'private-accessing' stamp: 'MML 11/14/2012 18:40'!
nbLibraryNameOrHandle
	^ '/apps/cmsbox3/system/liblimbo.dylib'! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:42'!
outString
	^ outString! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:42'!
outString: aString
	outString := aString! !

!LimboCommand methodsFor: 'private-accessing' stamp: 'MML 11/15/2012 09:12'!
pointers
	^ pointers ifNil: [ pointers := Set new ]! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/15/2012 15:24'!
primitiveArguments
	| bufferPointer |
	bufferPointer := NativeBoost allocate: self primitiveShellArguments size * 4.
	self registerPointer: bufferPointer named: 'buffer pointer'.
	self primitiveCollectArgumentPointersInto: bufferPointer.
	
	 ^ bufferPointer! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/15/2012 15:25'!
primitiveBufferFrom: aPointer at: anIndex
	| pointer string |
	pointer := NBExternalAddress new.
	self registerPointer: pointer named: 'out / err buffer'.
	pointer value: (aPointer nbUInt32AtOffset: anIndex).
	string := pointer readString.
		
	^ string! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/15/2012 15:24'!
primitiveCollectArgumentPointersInto: aPointer
	self primitiveShellArguments allButLast withIndexDo: [ :string :index || pointer | "0 terminated"
		pointer := NativeBoost allocate: string size + 1.
		self registerPointer: pointer named: string.
		NativeBoost memCopy: string to: pointer size: string size.
		pointer nbUInt8AtOffset: string size put: 0. "string terminating null char"
		aPointer nbUInt32AtOffset: (index - 1) * 4 put: pointer value ].
	
	aPointer nbUInt32AtOffset: (self primitiveShellArguments size - 1) * 4 put: 0! !

!LimboCommand methodsFor: 'private-accessing' stamp: 'MML 11/14/2012 17:30'!
primitiveErrorPointerIndex
	^ 4! !

!LimboCommand methodsFor: 'private-accessing' stamp: 'MML 11/14/2012 17:30'!
primitiveOutPointerIndex
	^ 0! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/15/2012 10:58'!
primitiveReadOut: outBuffer outLength: outLength error: errorBuffer errorLength: errorLength
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode >
	 ^ self nbCall: #( int read_buffers (NBExternalAddress outBuffer, int outLength, NBExternalAddress errorBuffer, int errorLength) ) ! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/15/2012 15:24'!
primitiveReadStringsOutLength: outLenghtPointer errorLength: errorLengthPointer
	| outLength errorLength outBuffer errorBuffer |
	outLength := outLenghtPointer nbUInt32AtOffset: 0.
	errorLength := errorLengthPointer nbUInt32AtOffset: 0.
	outBuffer := NativeBoost allocate: outLength + 1.
	self registerPointer: outBuffer named: 'out string buffer'.
	errorBuffer := NativeBoost allocate: errorLength + 1.
	self registerPointer: errorBuffer named: 'error string buffer'.
	
	self 
		primitiveReadOut: outBuffer 
		outLength: outLength 
		error: errorBuffer
		errorLength: errorLength.
		
	self 
		outString: outBuffer readString;
		errorString: errorBuffer readString! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/15/2012 16:36'!
primitiveRun
	| outLength errorLength |
	outLength := self integerPointer.
	errorLength := self integerPointer.
	self exitStatus: 
		(self 
			primitiveRun: self primitiveArguments
			outLength: outLength
			errorLength: errorLength).
		
	self exitStatus isNumber ifFalse: [ LimboError signal: 'Something went wrong when calling a NB primitive' ].
	
	self primitiveReadStringsOutLength: outLength errorLength: errorLength! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/15/2012 10:56'!
primitiveRun: argPointer outLength: outLengthPointer errorLength: errorLengthPointer
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode >
	 ^ self nbCall: #( int run_command (NBExternalAddress argPointer, NBExternalAddress outLengthPointer, NBExternalAddress errorLengthPointer) ) ! !

!LimboCommand methodsFor: 'private-accessing' stamp: 'MML 11/14/2012 18:05'!
primitiveShellArguments
	^ OrderedCollection new
		add: self command;
		addAll: self arguments;
		add: 0; "shell arguments are '\0' terminated"
		yourself! !

!LimboCommand methodsFor: 'printing' stamp: 'MML 11/14/2012 17:14'!
printCommand
	String streamContents: [ :stream |
		stream nextPutAll: self command.
		self arguments do: [ :string |
			stream 
				space;
				nextPutAll: string ] ]! !

!LimboCommand methodsFor: 'private-accessing' stamp: 'MML 11/15/2012 09:11'!
registerPointer: aPointer
	self pointers add: aPointer! !

!LimboCommand methodsFor: 'private-accessing' stamp: 'MML 11/15/2012 15:23'!
registerPointer: aPointer named: aString
	self pointers add: aString -> aPointer! !

!LimboCommand methodsFor: 'running' stamp: 'MML 11/15/2012 09:16'!
run
	[ self primitiveRun ] ensure: [ self freePointers ]! !
